#include <bits/stdc++.h>

using namespace std;
struct Station;
struct Line;
struct Train;
struct Passenger;
struct Event;

struct Station {
  int idx, x, y, typ;
  bool active = false;
};

struct Line {
  int idx;
  bool active = false;
};

struct Train {
  int idx;
  bool active = false;
};

struct Passenger {
  int idx, goal;
  Station* start = NULL;
  bool active = false;
};

struct Event {
  char typ;
  int time;
  int idx;
};

int eventCount, lineChangeLimit, trainSize, stationMaxPassengers;
int stationCount = 0;
int lineCount = 0;
int trainCount = 0;
int passengerCount = 0;
Station* stations;
Line* lines;
Train* trains;
Passenger* passengers;
vector<Event> events;

void simulate() {
  bool didStart = false;
  for(auto& event : events) {
    switch(event.typ) {
      case 's': {
        stations[event.idx].active = true;
        break;
      }
      case 'p': {
        passengers[event.idx].active = true;
        if (!didStart && passengers[event.idx].start->idx == 0) {
          cout << event.time << " r 0 " << stationCount;
          for(int i = 0; i < stationCount; i++) {
            cout << " " << i;
          }
          cout << "\n";
          cout << event.time << " z 0 0 0\n";
          cout << event.time << " e " << event.idx << " 0\n";
          didStart = true;
        }
        break;
      }
      case 'l': {
        lines[event.idx].active = true;
        break;
      }
      case 'z': {
        trains[event.idx].active = true;
        break;
      }
    }
  }
}

void readInput() {
  cin >> eventCount >> lineChangeLimit >> trainSize >> stationMaxPassengers >> stationCount >> passengerCount >> lineCount >> trainCount;

  stations = new Station[stationCount];
  lines = new Line[lineCount];
  trains = new Train[trainCount];
  passengers = new Passenger[passengerCount];

  for(int i = 0; i < eventCount; i++) {
    int aTime;
    char e;
    cin >> aTime >> e;

    switch(e) {
      case 's': {
        int i, x, y, a;
        cin >> i >> x >> y >> a;
        stations[i] = {
          .idx = i,
          .x = x,
          .y = y,
          .typ = a,
        };
        events.push_back({
          .typ = 's',
          .time = aTime,
          .idx = i
        });
        break;
      }
      case 'p': {
        int i, a, b;
        cin >> i >> a >> b;
        passengers[i] = {
          .idx = i,
          .goal = b,
          .start = &stations[a],
        };
        events.push_back({
          .typ = 'p',
          .time = aTime,
          .idx = i
        });
        break;
      }
      case 'l': {
        int i;
        cin >> i;
        lines[i] = {
          .idx = i,
        };
        events.push_back({
          .typ = 'l',
          .time = aTime,
          .idx = i
        });
        break;
      }
      case 'z': {
        int i;
        cin >> i;
        trains[i] = {
          .idx = i,
        };
        events.push_back({
          .typ = 'z',
          .time = aTime,
          .idx = i
        });
        break;
      }
    }
  }
}

int main() {
  srand(1337);

  readInput();
  simulate();

  return 0;
}
